/* Datei:  glvar.c
 * Autor: gkemnitz
 * letzte nderung:  03.11.2015
 *
 * Demonstration, wie der Compiler mit globalen 
 * und lokalen Variablen umgeht.
 * Test mit dem Simulator.
 */ 

#include <avr/io.h>
int16_t gi16;             // global 2 Byte, VZ, AW 0
uint8_t gu8;              // global 1 Byte, NVZ, AW 0

int main(void){
  uint8_t  lu8  = 0x2D;   // 1 Byte, NVZ, AW 0x2D
  int16_t  li16 = 0x51F4; // 2 Byte, VZ, AW 0x51F4
  uint8_t *lpu8 = &gu8;   // 2-Byte-Adresse fr 1-Byte NVZ,
                          // AW Adresse von gu8
  gi16  = li16 + 1;
  *lpu8 = lu8 - 4;        // Wertzuweisung an Adresse, hier gu8 
  lpu8  = &lu8;           // Zweisung Adresse von lu8
  *lpu8 = 0xA5;           // Wertzuweisung an Adresse, hier lu8
  lu8   = 23;
}
