/* Datei:  echo_bt.c
 * Author: gkemnitz
 * Datum:  29.10.2015
 *
 * Echoprogramm fr die PC-Kommunikation ber
 * Bluetooth (USART0)
 *
 * PmodUSBUSART an JE, Jumper JEX gekreuzt
 */

#include <avr/io.h>

int main(void){
  UCSR0C=0b110;                   // bertragungsformat 8N1
  UBRR0=51;                       // 9600 Baud
  UCSR0B=(1<<RXEN0)|(1<<TXEN0);   // Empfnger und Sender
  DDRJ = 0xFF;                    // ein; LEDs als Ausgang  

  uint8_t daten, Ct=0;            // Zhler LED-Ausgabe 

  while(1){
    while (!(UCSR0A & (1<<RXC0)));// warte auf ein Byte
    daten = UDR0;                 // Byte uebernehmen
    while (!(UCSR0A &(1<<UDRE0)));// warte Puffer frei
    UDR0 = daten;                 // Byte bergeben
    PORTJ=Ct;                     // Zhlausgabe auf
    Ct++;                         // LED erhhen
  }
}
